<%@ Page language="c#" AutoEventWireup="true" %>
<%@ Import NameSpace="System.IO" %>
<%@ Import NameSpace="System" %>
<%@ Import NameSpace="System.Data" %>
<%@ Import NameSpace="System.Web" %>
<%@ Import NameSpace="System.Text" %>
<script runat="server" language="C#">

	void Page_Load(object sender, EventArgs e)
		{
			string type = Request.QueryString["type"] == null ? string.Empty : Request.QueryString["type"].ToLower();
			_Name = Request.QueryString["name"] == null ? "export" : Request.QueryString["name"].ToLower();
			Response.Clear();

			switch (type)
			{
				case "xml":
					ExportXML();
					break;

				case "csv":
					ExportCSV();
					break;

				default:
					Response.Write("Wrong export type");
					break;
			}
		}

		private string _Name = "export";

		#region XML

		private void ExportXML()
		{
			DataTable dt = this.CleanUpDataTable(Session["dataview"] as DataView);
			StringBuilder sb = new StringBuilder();
			sb.Append("<" + dt.TableName + ">");
			
			foreach (DataRow row in dt.Rows)
			{
				sb.Append("<item>");
				
				for (int i = 0; i < dt.Columns.Count; i++)
				{
					sb.Append("<" + dt.Columns[i].ColumnName + ">" + row[i].ToString() + "</" + dt.Columns[i].ColumnName + ">");
				}
				
				sb.Append("</item>");
			}
			
			sb.Append("</" + dt.TableName + ">");

			Response.ClearHeaders();
			Response.AppendHeader("Content-Disposition", "attachment; filename=" + _Name + ".xml");
			Response.AppendHeader("Content-Length", sb.Length.ToString());
			Response.ContentType = "text/csv";
			Response.Write(sb.ToString());
			Response.End();
		}

		#endregion

		#region CSV

		private void ExportCSV()
		{
			DataTable dt = this.CleanUpDataTable(Session["dataview"] as DataView);
			StringBuilder sb = new StringBuilder();

			foreach (DataColumn col in dt.Columns)
			{
				sb.Append(col.ColumnName + ";");
			}

			sb.Remove(sb.Length - 1, 1);
			sb.Append(Environment.NewLine);

			foreach (DataRow row in dt.Rows)
			{
				for (int i = 0; i < dt.Columns.Count; i++)
				{
					sb.Append(row[i].ToString() + ";");
				}

				sb.Append(Environment.NewLine);
			}

			Response.ClearHeaders();
			Response.AppendHeader("Content-Disposition", "attachment; filename=" + _Name + ".csv");
			Response.AppendHeader("Content-Length", sb.Length.ToString());
			Response.ContentType = "text/csv";
			Response.Write(sb.ToString());
			Response.End();
		}

		#endregion
  
		private DataTable CleanUpDataTable(DataView dv)
		{
			DataTable dt = new DataTable(dv.Table.TableName);
			DataRow dtRow = null;

			for (int i = 0; i < dv.Table.Columns.Count; i++)
			{
				dt.Columns.Add(dv.Table.Columns[i].ColumnName, dv.Table.Columns[i].DataType);
				bool isInt = dv.Table.Columns[i].DataType == typeof(double);

				foreach (DataRow row in dv.Table.Rows)
				{
					if (isInt)
					{
						if (row[i] is DBNull)
							row[i] = "0";
					}
				}
			}

			foreach (DataRowView row in dv)
			{
				dtRow = dt.NewRow();

				for (int i = 0; i < dv.Table.Columns.Count; i++)
				{
					dtRow[i] = row[i].ToString();
				}

				dt.Rows.Add(dtRow);
			}

			return dt;
		}

</script>
